# Prendre et documenter des décisions

## Très courte description

**Patron de conception** afin de **documenter et justifiés les choix**, par exemple les **choix d'architectures** (**ADR**) dans l'industrie logiciels.


## Courte description

Il existe un patron de conception qui s'applique aux décisions architecturales, [ADR](https://adr.github.io/).

Ce patron peut-être **étendu à tout types de décisions**.


## Par où commencer ?

Voir le modèle proposé ici [_resources/model-decision.md](./_resources/modele-decision.md)


## Description

Les décisions ont besoins d'être **réfléchies** et **documentées**. 

Les resources ci-dessous proposent des guides et exemples d'implémentations.

* [Markdown (ADR)](ADRhttps://adr.github.io/madr/) | _propose des modèles et outils pour maintenir une liste de décisions en Markdown_
* [Saisie de décision](https://schubmat.github.io/DecisionCapture/) | _encore des modèles_


#### Définition
##### **Architectural decision (AD)** _Décision architecturale_

**Choix justifié qui répond à une exigence** fonctionnelle ou non fonctionnelle **significative** sur le plan architectural.

Les **décisions d'architecture** répondent à des **exigences importantes** ; elles sont perçues comme **difficiles à prendre** et/ou **coûteuses à modifier**.


##### Architecturally Significant Requirement (ASR)

Les **exigences architecturallement significatives** sont celles qui ont un effet **mesurable** sur l'architecture. 

Il s'agit d'**un sous-ensemble d'exigences**, le sous-ensemble qui affecte l'architecture d'un système de **manière mesurable** et **identifiable**.


## En savoir plus

* **ADR**: https://adr.github.io/
* **Saisie de Décision**: https://schubmat.github.io/DecisionCapture/


### Voir aussi

##### Exemples
* https://forge.liiib.re/libre.sh/libre.sh/-/tree/develop/docs


## License

[CC BY-SA 2.0 FR](https://creativecommons.org/licenses/by-sa/2.0/fr/)

### Autheurices
* grincheuxx
* reminec @ acides.org (Tedomum.net)

_Librement traduit depuis adr.github.io_

## Versions
### v0.1.0
_Date : 26 mars 2023 | Temps rédaction : 25min_ | reminec
* Reformatage 
* Editions
* Ne concerne plus que les ADR mais toutes les décisions

### v0.0.2
_Date : 17 mars 2023 | Temps rédaction : 30min_ | reminec
* Reformatage
* Editions

### v0.0.1
_Date : 17 mars 2023 | Temps rédaction : 30min_ | reminec, grincheuxx
* Introduction à l'ADR par 2 novices sans experts

## Remerciements

* [PierreO.](https://mastodon.indie.host/@pierreozoux) @ [indiehosters.net](https://indiehosters.net) - Pour avoir soufflé ce patron de conception