# Saisie de contenu texte interprété en Markdown (Tags, FrontMatter)

## Courte Description

Interprétation du contenu au format Markdown, utilisation du FrontMatter, et des tags.

## Description

### Processus

``` mermaid
flowchart TB
    Saisie["Saisie de texte"] --> |Représenter comme| Arbre("Un arbre noeudal MD")
    Arbre --> |Parcours les noeuds| ProchainNoeud("Noeud")
    
    subgraph Analyse d'un noeud
    ProchainNoeud -->|Extraction de| Tags("Tags (#FichePratique #OutilsVisio)")
    ProchainNoeud -->|Extraire les| MetaNoeud("Métadonnées du noeud")
    ProchainNoeud -->|Extraire le | ContenuNoeud("Contenu")
    ContenuNoeud -->|Extraction d'autres| MetaNoeud("Métadonnées")
    Tags-->|Ajout au| MetaNoeud
    ContenuNoeud --> ContenuFM("ContenuMD et FrontMatter")
    MetaNoeud --> ContenuFM
    end
    subgraph Publication du noeud
    ContenuFM -->|Interpréter| Objet("Interprétations")
    Objet -->|Publier| Rendus("Différentes Vues")
    end
```
#### Comportements

```gherkin-fr

Fonctionnalité: …
  Dans le but de pouvoir saisir du contenu texte et de pouvoir le réutiliser  
  En tant qu'utilisateurice novice ou avancé
  Je veux pouvoir écrire du Markdown via un éditeur, accéder à la source, le prévisualiser.
  Je peut aussi avoir la main sur les métadonnées du contenu (ex: FrontMatter).
  Je peut avoir un usage avancé des Tags (ou Hashtags).
  Je peut avoir un usage naturel du balisage et des métadonnées
  Je veux que la plupart de mon contenu saisi puisse être réutilisable
  Je veux donc que la plupart de mon contenu saisi puisse être analysé, interprété, rendu.

Règle: Saisie de contenu texte interprété en Markdown

Background: ~

Scénario: Saisie d'un contenu texte
  Étant donné un contenu 'sample.md'
  Quand le contenu est publié
  Alors il a été interprété en Markdown
  
Règle: Analyse et interprétation des tags

Background: ~  

Scénario: Saisie d'un document texte avec des Tags
  Étant donné un contenu 'FichePratique-OutilsVisio.md'
  Et une métadonnée 'tags' qui contient '["DocumentMD", "OutilsVisio", "FichePratique"]'
  Quand le contenu est publié
  Alors il a été interprété en Markdown
  Et on peut le retrouver par son tag '#FichePratique'
  Et on peut le retrouver par ses tags '#FichePratique #OutilsVisio'
 ```gherkin

